
#line 1 "global.h"
#ifndef __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#define __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#define __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_global_h__
#endif // __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__

#line 1 "global.h"

#line 11 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/global.h"
class Automatic;

#line 1 "global.h"

#line 16 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/global.h"

#ifndef __ac_h_
#define __ac_h_
#ifdef __cplusplus
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 32768, EXECUTION = 65536, CONSTRUCTION = 131072, DESTRUCTION = 262144 };
  enum Protection { PROT_NONE, PROT_PRIVATE, PROT_PROTECTED, PROT_PUBLIC };
  enum Specifiers { SPEC_NONE = 0x0 , SPEC_STATIC = 0x1, SPEC_MUTABLE = 0x2, SPEC_VIRTUAL = 0x4 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    struct { char _array[sizeof (T)]; } _data;
    ~ResultBuffer () { ((T&)_data).T::~T(); }
    operator T& () const { return (T&)_data; }
  };
  template <typename T, typename N> struct TL {
    typedef T type; typedef N next; enum { ARGS = next::ARGS + 1 };
  };
  struct TLE { enum { ARGS = 0 }; };
  template <typename T> struct Referred { typedef T type; };
  template <typename T> struct Referred<T &> { typedef T type; };
  template <typename TL, int I> struct Arg {
    typedef typename Arg<typename TL::next, I - 1>::Type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename TL> struct Arg<TL, 0> {
    typedef typename TL::type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename T> int ttest(...);
  template <typename T> char ttest(typename T::__TI const volatile *);
  template<typename T> struct HasTypeInfo {
    enum { RET=((sizeof(ttest<T>(0))==1)?1:0) };
  };
  template<typename T, int HAVE = HasTypeInfo<T>::RET> struct TypeInfo {
    enum { AVAILABLE = 0 };
  };
  template<typename T> struct TypeInfo<T, 1> : T::__TI {
    enum { AVAILABLE = 1 };
	 };
  template<typename T> struct RT {};
  template<typename T> RT<T> rt_deduce (const T&) { return RT<T>(); }
  struct Cnv { template<typename T> operator RT<T>() const { return RT<T>(); }};
  #define __AC_TYPEOF(expr) (1?AC::Cnv():AC::rt_deduce(expr))
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (unsigned long int, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __cplusplus
#endif // __ac_h_

#line 1 "global.h"
/**
 * Defines the parameters of the system
 **/

#ifndef GLOBAL_H
#define GLOBAL_H

#define NUMBEROFUSERS	5
//#define DEBUG_MODEL 	1

#include <string>
#include <iomanip>	
#include "systemc.h"


/*
 * direction: 1: up, 0: idle, -1: down
 * floor: the current position
 */
typedef struct LiftStatus {
#line 103 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/global.h"

  template <typename, int = 0> struct __BYPASSLiftStatus {};
  template <typename, int> friend struct __BYPASSLiftStatus;
#line 20 "global.h"

	int direction;
	int floor;

  friend class ::Automatic;

#line 23 "global.h"
} lift_status_t;


/*
 * type, 0 : internal, 1 : external
 * targetfloor: desired floor, -1 if external
 * fromfloor: external request from, -1 if internal
 * direction: external request direction, 1: up, -1: down, 0 if internal
 * inlift: internal request in the lift inlift, -1 if external
 */

class Request {
#line 127 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/global.h"
public:
  template <typename, int = 0> struct __BYPASSRequest {};
  template <typename, int> friend struct __BYPASSRequest;
private:
#line 34 "global.h"


public:

	// constructor
	Request (int _type = -1, int _fromfloor = -1, int _targetfloor = -1, int _inlift = -1, int _direction = -1) {
		
		type = _type;
		fromfloor = _fromfloor;
		targetfloor = _targetfloor;
		inlift = _inlift;
		direction = _direction;
	}

	inline bool operator == (const Request& rhs) const {
		return (rhs.type == type && 
			    rhs.fromfloor == fromfloor &&
			    rhs.targetfloor == targetfloor &&
			    rhs.inlift == inlift &&
			    rhs.direction == direction);
	}

	inline Request& operator = (const Request& rhs) {
		type = rhs.type;
		fromfloor = rhs.fromfloor;
		targetfloor = rhs.targetfloor;
		inlift = rhs.inlift;
		direction = rhs.direction;

		return *this;
	}

	inline friend void sc_trace(sc_trace_file *tf, const Request& v, 
		const std::string& NAME) {
		sc_trace(tf, v.type, NAME + ".type");
		sc_trace(tf, v.fromfloor, NAME + ".fromfloor");
		sc_trace(tf, v.targetfloor, NAME + ".targetfloor");
		sc_trace(tf, v.inlift, NAME + ".inlift");
		sc_trace(tf, v.direction, NAME + ".direction");
	}

	inline friend ostream& operator << (ostream& os, Request const & v) {
		os << v.type << " "  << v.fromfloor << " " 
		   << v.targetfloor << " " << v.inlift << " "  
		   << v.direction;
	
		return os;
	}


private:
	int type;
	int fromfloor;
	int targetfloor;
	int inlift;
	int direction;


  friend class ::Automatic;

#line 91 "global.h"
};

#endif


#line 199 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/global.h"

#ifdef __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_global_h__
#ifdef __ac_need__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#ifndef __ac_have__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#define __ac_have__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#include "aspect_definitions.ah"
#endif
#endif
#undef __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#undef __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_global_h__
#endif // __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_global_h__
