
#line 1 "liftsystem.cc"
#ifndef __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#define __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#define __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_liftsystem_cc__
#endif // __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__

#line 1 "liftsystem.cc"

#line 11 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
class Automatic;

#line 1 "liftsystem.cc"

#line 16 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

#ifndef __ac_h_
#define __ac_h_
#ifdef __cplusplus
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 32768, EXECUTION = 65536, CONSTRUCTION = 131072, DESTRUCTION = 262144 };
  enum Protection { PROT_NONE, PROT_PRIVATE, PROT_PROTECTED, PROT_PUBLIC };
  enum Specifiers { SPEC_NONE = 0x0 , SPEC_STATIC = 0x1, SPEC_MUTABLE = 0x2, SPEC_VIRTUAL = 0x4 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    struct { char _array[sizeof (T)]; } _data;
    ~ResultBuffer () { ((T&)_data).T::~T(); }
    operator T& () const { return (T&)_data; }
  };
  template <typename T, typename N> struct TL {
    typedef T type; typedef N next; enum { ARGS = next::ARGS + 1 };
  };
  struct TLE { enum { ARGS = 0 }; };
  template <typename T> struct Referred { typedef T type; };
  template <typename T> struct Referred<T &> { typedef T type; };
  template <typename TL, int I> struct Arg {
    typedef typename Arg<typename TL::next, I - 1>::Type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename TL> struct Arg<TL, 0> {
    typedef typename TL::type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename T> int ttest(...);
  template <typename T> char ttest(typename T::__TI const volatile *);
  template<typename T> struct HasTypeInfo {
    enum { RET=((sizeof(ttest<T>(0))==1)?1:0) };
  };
  template<typename T, int HAVE = HasTypeInfo<T>::RET> struct TypeInfo {
    enum { AVAILABLE = 0 };
  };
  template<typename T> struct TypeInfo<T, 1> : T::__TI {
    enum { AVAILABLE = 1 };
	 };
  template<typename T> struct RT {};
  template<typename T> RT<T> rt_deduce (const T&) { return RT<T>(); }
  struct Cnv { template<typename T> operator RT<T>() const { return RT<T>(); }};
  #define __AC_TYPEOF(expr) (1?AC::Cnv():AC::rt_deduce(expr))
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (unsigned long int, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __cplusplus
#endif // __ac_h_

#line 1 "liftsystem.cc"
/*
 * This module models the behavior of a multi-lift systems.
 * The system consists of NumberofLifts lifts and NumberofFloors floors.
 * Each lift can move a distance of one floor in 1s
 */



#line 1 "liftsystem.h"

#line 93 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

#ifndef __ac_fwd_Automatic__
#define __ac_fwd_Automatic__
class Automatic;
namespace AC {
  __attribute((always_inline)) inline void invoke_Automatic_Automatic__a0_after ();
  __attribute((always_inline)) inline void invoke_Automatic_Automatic__a1_after ();
}
#endif

#ifndef __ac_need__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#define __ac_need__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#endif

#line 1 "liftsystem.h"
/*
 * This module models the behavior of a multi-lift systems.
 * The system consists of NumberofLifts lifts and NumberofFloors floors.
 * Each lift can move a distance of one floor in 0.5s
 */


#ifndef LIFTSYSTEM_H
#define LIFTSYSTEM_H

#include "systemc.h"
#include <tlm.h>
#include <limits.h>

#line 1 "global.h"
/**
 * Defines the parameters of the system
 **/

#ifndef GLOBAL_H
#define GLOBAL_H

#define NUMBEROFUSERS	5
//#define DEBUG_MODEL 	1

#include <string>
#include <iomanip>	
#include "systemc.h"


/*
 * direction: 1: up, 0: idle, -1: down
 * floor: the current position
 */
typedef struct LiftStatus {
#line 144 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

  template <typename, int = 0> struct __BYPASSLiftStatus {};
  template <typename, int> friend struct __BYPASSLiftStatus;
#line 20 "global.h"

	int direction;
	int floor;

  friend class ::Automatic;

#line 23 "global.h"
} lift_status_t;


/*
 * type, 0 : internal, 1 : external
 * targetfloor: desired floor, -1 if external
 * fromfloor: external request from, -1 if internal
 * direction: external request direction, 1: up, -1: down, 0 if internal
 * inlift: internal request in the lift inlift, -1 if external
 */

class Request {
#line 168 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
public:
  template <typename, int = 0> struct __BYPASSRequest {};
  template <typename, int> friend struct __BYPASSRequest;
private:
#line 34 "global.h"


public:

	// constructor
	Request (int _type = -1, int _fromfloor = -1, int _targetfloor = -1, int _inlift = -1, int _direction = -1) {
		
		type = _type;
		fromfloor = _fromfloor;
		targetfloor = _targetfloor;
		inlift = _inlift;
		direction = _direction;
	}

	inline bool operator == (const Request& rhs) const {
		return (rhs.type == type && 
			    rhs.fromfloor == fromfloor &&
			    rhs.targetfloor == targetfloor &&
			    rhs.inlift == inlift &&
			    rhs.direction == direction);
	}

	inline Request& operator = (const Request& rhs) {
		type = rhs.type;
		fromfloor = rhs.fromfloor;
		targetfloor = rhs.targetfloor;
		inlift = rhs.inlift;
		direction = rhs.direction;

		return *this;
	}

	inline friend void sc_trace(sc_trace_file *tf, const Request& v, 
		const std::string& NAME) {
		sc_trace(tf, v.type, NAME + ".type");
		sc_trace(tf, v.fromfloor, NAME + ".fromfloor");
		sc_trace(tf, v.targetfloor, NAME + ".targetfloor");
		sc_trace(tf, v.inlift, NAME + ".inlift");
		sc_trace(tf, v.direction, NAME + ".direction");
	}

	inline friend ostream& operator << (ostream& os, Request const & v) {
		os << v.type << " "  << v.fromfloor << " " 
		   << v.targetfloor << " " << v.inlift << " "  
		   << v.direction;
	
		return os;
	}


private:
	int type;
	int fromfloor;
	int targetfloor;
	int inlift;
	int direction;


  friend class ::Automatic;

#line 91 "global.h"
};

#endif


#line 1 "liftsystem.h"

#line 242 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

#ifndef __ac_guard__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#define __ac_guard__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__

#line 1 "aspect_definitions.ah"
#ifndef ASPECT_DEFINITIONS_AH
#define ASPECT_DEFINITIONS_AH

#include <systemc>

#line 1 "monitor_multilift.h"
/*
 * This code is automatically generated by MAG
 * Copyright (C) 2014 Chan Ngo, INRIA
 * chan.ngo@inria.fr
 */


#ifndef MONITOR_MULTILIFT_H
#define MONITOR_MULTILIFT_H

#include <systemc.h>
#include <iostream>
#include <fstream>
#include <cassert>
#include <cstdlib>
#include <sstream>
#include <string.h>

/*
 * User objects, forward declaration
 */

class LiftSystem;

/*
 * Monitor class declaration
 */

class monitor_multilift0 : public sc_core::mon_prototype {
#line 283 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
public:
  template <typename, int = 0> struct __BYPASSmonitor_multilift0 {};
  template <typename, int> friend struct __BYPASSmonitor_multilift0;
private:
#line 29 "monitor_multilift.h"


public:

  /*
   * Constructor
   */

  monitor_multilift0(sc_core::mon_observer* obs, LiftSystem* obj0);

  /*
   * Destructor
   */

  ~monitor_multilift0();

  /*
   * Simulate a step of the monitor.
   */

  void step();

  /*
   * Kernel-level callbacks and user-code callbacks
   */

  void callback_userloc_MovingLift();


  // Value callbacks (if any)


  /*
   * Attributes
   */

private: 

  sc_core::mon_observer* observer;
  mon_status_t status;
  LiftSystem* pnt_liftsystem;
  bool UpdateLiftStatus;
  bool MovingLift;

  friend class ::Automatic;

#line 72 "monitor_multilift.h"
};



/*
 * This object is derived from mon_observer defined in the SystemC
 * modified kernel. Thus, we can pass it as an argument to the classes
 * implementing the monitors.
 */
class local_observer : public sc_core::mon_observer {
#line 346 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
public:
  template <typename, int = 0> struct __BYPASSlocal_observer {};
  template <typename, int> friend struct __BYPASSlocal_observer;
private:
#line 81 "monitor_multilift.h"


 public:

  // Constructor
  local_observer(unsigned int verbosity, LiftSystem* pnt_liftsystem);

  ~local_observer();

  static local_observer* getInstance();

  static local_observer* createInstance(unsigned int verbosity, LiftSystem* pnt_liftsystem);

 private:

  static local_observer* m_instance;


  friend class ::Automatic;

#line 98 "monitor_multilift.h"
};

#endif

#line 7 "aspect_definitions.ah"
#include <iostream>

class Automatic {
#line 381 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
public:
  template <typename, int = 0> struct __BYPASSAutomatic {};
  template <typename, int> friend struct __BYPASSAutomatic;
private:
#line 9 "aspect_definitions.ah"



  // Declare the monitor objects friends, for access to private data
  
#line 13 "aspect_definitions.ah"


  
#line 17 "aspect_definitions.ah"
; // class


  // Instrumentation code for '		UpdateLiftStatus="% LiftSystem::UpdateLiftStatus(...)":exit'
  
#line 21 "aspect_definitions.ah"

#line 404 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

public: void __a0_after 
#line 21 "aspect_definitions.ah"
() {

#ifdef DEBUG_INSTRUMENTATION
      std::cout << "Join Point signature: " << JoinPoint::signature() << std::endl;
      std::cout << "Using advice: execution(\"% LiftSystem::UpdateLiftStatus(...)\"): after()" << std::endl;
      std::cout << "For user location 		UpdateLiftStatus=\"% LiftSystem::UpdateLiftStatus(...)\":exit" << std::endl;
#endif

  }
#line 417 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

private:

#line 29 "aspect_definitions.ah"
 // advice


  // Instrumentation code for '		MovingLift="% LiftSystem::MovingLift(...)":exit'
  
#line 33 "aspect_definitions.ah"

#line 429 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

public: void __a1_after 
#line 33 "aspect_definitions.ah"
() {

#ifdef DEBUG_INSTRUMENTATION
      std::cout << "Join Point signature: " << JoinPoint::signature() << std::endl;
      std::cout << "Using advice: execution(\"% LiftSystem::MovingLift(...)\"): after()" << std::endl;
      std::cout << "For user location 		MovingLift=\"% LiftSystem::MovingLift(...)\":exit" << std::endl;
#endif

    {
      mon_observer* observer = local_observer::getInstance();
      monitor_multilift0* mon = (monitor_multilift0*) observer->get_monitor_by_index(0);
      mon->callback_userloc_MovingLift();
    }
  }
#line 447 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

private:

#line 46 "aspect_definitions.ah"
 // advice




public:
  static Automatic *aspectof () {
    static Automatic __instance;
    return &__instance;
  }
  static Automatic *aspectOf () {
    return aspectof ();
  }
private:

#line 49 "aspect_definitions.ah"
};
#line 469 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

namespace AC {
  __attribute((always_inline)) inline void invoke_Automatic_Automatic__a0_after () {
    ::Automatic::aspectof()->__a0_after ();
  }
  __attribute((always_inline)) inline void invoke_Automatic_Automatic__a1_after () {
    ::Automatic::aspectof()->__a1_after ();
  }
} 

#line 49 "aspect_definitions.ah"
 // Automatic



#endif

#line 7 "liftsystem.h"
#endif

#line 17 "liftsystem.h"
struct LiftSystem : ::sc_core::sc_module {
#line 492 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

  template <typename, int = 0> struct __BYPASSLiftSystem {};
  template <typename, int> friend struct __BYPASSLiftSystem;
#line 17 "liftsystem.h"


	SC_HAS_PROCESS(LiftSystem);
	
public:

	// ports to connect to users
	sc_in < Request > reqs_p[NUMBEROFUSERS];
	sc_event receive_req_e;

	// Contructor
	LiftSystem(sc_module_name name, unsigned int lifts, unsigned int floors);


	void GetRequests();

	void UpdateLifts();

	void ReceiveRequests();

	void AssignExternalRequest(int level, int up);

	void AssignInternalRequest(int lift, int level);

	// a lift's behavior
	
#line 523 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
public: __attribute__((always_inline)) inline void __exec_old_UpdateLiftStatus(int lift);

#line 42 "liftsystem.h"
void UpdateLiftStatus(int lift);

	
#line 530 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
public: __attribute__((always_inline)) inline void __exec_old_MovingLift(int lift);

#line 44 "liftsystem.h"
void MovingLift(int lift);

	// get target floor to move for a lift
	int GetFloortoMove_Ext(int fromfloor, std::vector < int > targets, int direction);

	int GetFloortoMove_Int(int fromfloor, std::vector < int > targets);

	int ComputeMinimumDistance(int level, int up);

	// passby check
	void PassbyCheck();

private:
	// mutex for access shared data
	sc_mutex update_exreqs_up;
	sc_mutex update_exreqs_down;
	sc_mutex update_intreqs;
	sc_mutex update_liftstatus;

	// number of lifts
	unsigned int NumberofLifts;

	// number of floors
	unsigned int NumberofFloors;

	std::vector< int > ExternalRequestsUp;

	std::vector< int > ExternalRequestsDown;
	
	std::vector< std::vector< int > > InternalRequests;

	// model the lifts
	std::vector< lift_status_t > LiftStatus;

	// passby
	int passby;

   private:

#line 16 ""
 friend class monitor_multilift0 ;
  friend class ::Automatic;

#line 81 "liftsystem.h"
};

#endif
#line 12 "liftsystem.cc"
LiftSystem::LiftSystem(sc_module_name name, unsigned int lifts, unsigned int floors) : sc_module(name) {

	// intialization
	NumberofLifts = lifts;
	NumberofFloors = floors;

	// init the requests
	InternalRequests = std::vector< std::vector< int > >(lifts, std::vector< int >(floors, -1));
	ExternalRequestsUp = std::vector< int >(floors, -1);
	ExternalRequestsDown = std::vector< int >(floors, -1);

	// init the lifts - at beginning all lifts are at bottom floor and idle
	for (int i = 0; i < lifts; i++) {
		lift_status_t l;
		l.direction = 0;
		l.floor = 0;
		LiftStatus.push_back(l);
	}

	// passby
	passby = 0;

	// thread - get requests
	SC_THREAD(GetRequests);
	for (int i = 0; i < NUMBEROFUSERS; i++) {
		sensitive << reqs_p[i];
	}
	// notified when receving requests
	SC_METHOD(ReceiveRequests);
	for (int i = 0; i < NUMBEROFUSERS; i++) {
		sensitive << reqs_p[i];
	}
	dont_initialize();

	// thread - update lifts
	SC_THREAD(UpdateLifts);
}

void LiftSystem::ReceiveRequests() {

	receive_req_e.notify( SC_ZERO_TIME );
}


/*
 * control process of the controller
 */
void LiftSystem::GetRequests() {

	while (true) {
		wait(receive_req_e);

		int type = -1;
		int fromfloor = -1;
		int targetfloor = -1;
		int inlift = -1;
		int direction = 0;

		for (int i = 0; i < NUMBEROFUSERS; i++) {
			std::stringstream req;
			req << reqs_p[i].read();

			// get the request's element
			req >> type;
			req >> fromfloor;
			req >> targetfloor;
			req >> inlift;
			req >> direction;
			req.clear();

			// get internal request
			if (type == 0) {
				// assign it
				if (inlift != -1 && targetfloor != -1) {
					AssignInternalRequest(inlift, targetfloor);
				}
			}
			// get external request
			else if (type == 1) {
				// assign it
				if (fromfloor != -1 && direction != 0) {
					AssignExternalRequest(fromfloor, direction);
				}
			}
		}
	}
}

/*
 * Passby check
 */
void LiftSystem::PassbyCheck() {
	passby = 0;

	update_exreqs_up.lock();
	update_exreqs_down.lock();
	update_liftstatus.lock();
	// passby check
	for (int i = 0; i < NumberofFloors; i++) {
		for (int j = 0; j < NumberofLifts; j++) {
			if (ExternalRequestsUp[i] > -1) {
				if (LiftStatus[j].floor == i && LiftStatus[j].direction == 1 && ExternalRequestsUp[i] != j) {
					passby = 1;
					#ifdef DEBUG_MODEL
    				std::cout << "Passby external request up" << std::endl;
    				#endif
				} 
			}

			if (ExternalRequestsDown[i] > -1) {
				if (LiftStatus[j].floor == i && LiftStatus[j].direction == -1 && ExternalRequestsDown[i] != j) {
					passby = 1;
					#ifdef DEBUG_MODEL
    				std::cout << "Passby external request down" << std::endl;
    				#endif
				} 
			}
		}
	}
	update_liftstatus.unlock();
	update_exreqs_down.unlock();
	update_exreqs_up.unlock();
}

/*
 * Behaviors of lifts
 */
void LiftSystem::UpdateLifts() {

	while (true) {

		// update the lifts status		
		for (int i = 0; i < NumberofLifts; i++) {
			// update the status of lifts
			UpdateLiftStatus(i);
		}

		// each 1s lifts can move a distance of one floor
		wait(1, SC_SEC);
		// move the lifts
		for (int i = 0; i < NumberofLifts; i++) {
			MovingLift(i);
		}

		// passby check
		PassbyCheck();
	}
}

/*
 * Add an internal request in the lift "lift" to floor "level"
 */
void LiftSystem::AssignInternalRequest(int lift, int level) {

	// lock mutex
	update_intreqs.lock(); // wait until mutex is available

	#ifdef DEBUG_MODEL
    std::cout << "Add interal request (lift: " << lift << ", floor: " << level  << ")" << std::endl;
    #endif
    InternalRequests[lift][level] = 1;
	
	update_intreqs.unlock();
}


int LiftSystem::ComputeMinimumDistance(int level, int up) {
	int minimumDistance = INT_MAX;
	int chosenLift = -1;

	for (int i = 0; i < NumberofLifts; i++) {
		int distance = -1;
		
		update_liftstatus.lock(); // wait till mutex is available

		lift_status_t currlift = LiftStatus[i];

		// going up request
		if (up == 1) {
			// current lift is going up
			if (currlift.direction == 1) {
				if (currlift.floor  <= level)
					distance = level - currlift.floor;
				else 
					distance = (NumberofFloors - 1 - currlift.floor) + (NumberofFloors -1 - level);
			}
			// current lift is waiting
			else if (currlift.direction == 0) {
				if (currlift.floor  <= level)
					distance = level - currlift.floor;
				else 
					distance = currlift.floor - level;
			}
			// current lift is going down
			else {
					distance = currlift.floor + level;
			}
		}
		// going down request
		else {
			// current lift is going up
			if (currlift.direction == 1) {
				if (currlift.floor  <= level)
					distance = (NumberofFloors - 1 - currlift.floor) + (NumberofFloors -1 - level);
			}
			// current lift is waiting
			else if (currlift.direction == 0) {
				if (currlift.floor  <= level)
					distance = level - currlift.floor;
				else 
					distance = currlift.floor - level;
			}
			// current lift is going down
			else {
				if (currlift.floor  < level)
					distance = currlift.floor + level;
				else 
					distance = currlift.floor - level;
			}
		}

		// update the distance
		if (distance < minimumDistance) {
			chosenLift = i;
			minimumDistance = distance;
		}

		update_liftstatus.unlock();
	}

	return chosenLift;
}

/*
 * Add an external request at floor "level" with direction "up"
 */
void LiftSystem::AssignExternalRequest(int level, int up) {

	// find the lift with minimum distance from the floor "level"
	int chosenLift = ComputeMinimumDistance(level, up);
	
	// at ground floor, going down is not possible
	if (level == 0 && up == -1) {
		return;
	}

	// at top floor, going up is not possible

	if (level == (NumberofFloors - 1) && up == 1) {
		return;
	}

	if (up == 1) {
		update_exreqs_up.lock();
		// external request at floor "level" to go up is already requested
		if (ExternalRequestsUp[level] >= 0) {
			update_exreqs_up.unlock();
			return;
		}
		// add new external request to go up
		else {
			#ifdef DEBUG_MODEL
    		std::cout << "Add external request (floor: " << level << ", direction: " << up << ")" << std::endl;
    		#endif
			ExternalRequestsUp[level] = chosenLift;
			update_exreqs_up.unlock();
		}
	}

	if (up == -1) {
		update_exreqs_down.lock();
		// external request at floor "level" to go down is already requested
		if (ExternalRequestsDown[level] >= 0) {
			update_exreqs_down.unlock();
			return;
		}
		// add new request to go down
		else {
			#ifdef DEBUG_MODEL
    		std::cout << "Add external request (floor: " << level << ", direction: " << up << ")" << std::endl;
    		#endif
			ExternalRequestsDown[level] = chosenLift;
			update_exreqs_down.unlock();
		}
	}
}


int LiftSystem::GetFloortoMove_Int(int fromfloor, std::vector < int > targets) {
	
	int minidistance = INT_MAX;
	int chosenfloor = -1;
	int distance = -1;

	for (int i = 0; i < targets.size(); i++) {

		if (targets[i] >= fromfloor)
			distance = targets[i] - fromfloor;
		else
			distance = fromfloor - targets[i];

		// update the distance
		if (distance < minidistance) {
			minidistance = distance;
			chosenfloor = i; 
		}
	}

	return chosenfloor;
}

int LiftSystem::GetFloortoMove_Ext(int fromfloor, std::vector < int > targets, int direction) {

	int minidistance = INT_MAX;
	int chosenfloor = -1;
	int distance = -1;

	for (int i = 0; i < targets.size(); i++) {
	
		if (direction == 0) {
			if (targets[i] >= fromfloor)
				distance = targets[i] - fromfloor;
			else
				distance = fromfloor - targets[i];
		}
		else if (direction == 1) {
			if (targets[i] >= fromfloor)
				distance = targets[i] - fromfloor;
			else
				distance = (NumberofFloors - 1 - fromfloor) + (NumberofFloors -1 - targets[i]);
		}
		else {
			if (targets[i] <= fromfloor)
				distance = fromfloor - targets[i];
			else
				distance = fromfloor + targets[i];
		}

		// update the distance
		if (distance < minidistance) {
			minidistance = distance;
			chosenfloor = i; 
		}

	}

	return chosenfloor;
}


/* 
 * update the lift postions
 */
void LiftSystem::UpdateLiftStatus(int lift) 
#line 936 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
{
      this->__exec_old_UpdateLiftStatus(lift);
  AC::invoke_Automatic_Automatic__a0_after ();
  
}
__attribute__((always_inline)) inline void LiftSystem::__exec_old_UpdateLiftStatus(int lift)
#line 365 "liftsystem.cc"
{

	bool becomewaiting = true;

	// get the lift
	update_liftstatus.lock();

	lift_status_t l = LiftStatus[lift];
	// check exreq up
	update_exreqs_up.lock(); // wait until mutex is available

    if (ExternalRequestsUp[l.floor] == lift) {
    	#ifdef DEBUG_MODEL
    	std::cout << "Clear external (up) request for lift " << lift << " at floor " << l.floor << " direction " << l.direction << std::endl;
    	#endif
    	ExternalRequestsUp[l.floor] = -1;
    }
    update_exreqs_up.unlock(); // unlock mutex


    // check exreq down
	update_exreqs_down.lock(); // wait until mutex is available

    if (ExternalRequestsDown[l.floor] == lift) {
    	#ifdef DEBUG_MODEL
    	std::cout << "Clear external (down) request for lift " << lift << " at floor " << l.floor << " direction " << l.direction << std::endl;
    	#endif
    	ExternalRequestsDown[l.floor] = -1;
    }
    update_exreqs_down.unlock(); // unlock mutex

    // check intreq
	update_intreqs.lock(); // wait until mutex is available
   
    // the lift arrived
    if (InternalRequests[lift][l.floor] > -1) {
    	#ifdef DEBUG_MODEL
    	std::cout << "Clear internal request for lift " << lift << " at floor " << l.floor << " direction " << l.direction << std::endl;
    	#endif
    	InternalRequests[lift][l.floor] = -1;
    }

    // become waiting
    for (int i = 0; i < InternalRequests[lift].size(); i++) {
    	if (InternalRequests[lift][i] > -1) {
    		becomewaiting = false;
    	}
    }
    if (becomewaiting) {
    	l.direction = 0;
    }

    update_intreqs.unlock(); // unlock mutex
	
	update_liftstatus.unlock();
}


void LiftSystem::MovingLift(int lift) 
#line 1003 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"
{
      this->__exec_old_MovingLift(lift);
  AC::invoke_Automatic_Automatic__a1_after ();
  
}
__attribute__((always_inline)) inline void LiftSystem::__exec_old_MovingLift(int lift)
#line 423 "liftsystem.cc"
{

	std::vector < int > isUpdate_ExreqUp;
	std::vector < int > isUpdate_ExreqDown;
	std::vector < int > isUpdate_Intreq;
	int chosenfloor = -1;

	update_liftstatus.lock();

	// get the lift
	lift_status_t l = LiftStatus[lift];

	// check exreq up
	isUpdate_ExreqUp.clear();

	update_exreqs_up.lock(); // wait until mutex is available

    for (int i = 0; i < ExternalRequestsUp.size(); i++) {
    	if (ExternalRequestsUp[i] == lift) {
    		if (l.floor == i) {
    			ExternalRequestsUp[i] = -1;
    		}
    		else {
    			isUpdate_ExreqUp.push_back(i);
    		}
    	}
    }
    update_exreqs_up.unlock(); // unlock mutex

    // check exreq down
	isUpdate_ExreqDown.clear();

	update_exreqs_down.lock(); // wait until mutex is available

    for (int i = 0; i < ExternalRequestsDown.size(); i++) {
    	if (ExternalRequestsDown[i] == lift) {
    		if (l.floor == i) {
    			ExternalRequestsDown[i] = -1;
    		}
    		else {
    			isUpdate_ExreqDown.push_back(i);
    		}
    	}
    }
    update_exreqs_down.unlock(); // unlock mutex

    // check intreq
	isUpdate_Intreq.clear();

	update_intreqs.lock(); // wait until mutex is available
   
    for (int i = 0; i < InternalRequests[lift].size(); i++) {
    	if (InternalRequests[lift][i] > -1) {
    		if (l.floor == i) {
    			InternalRequests[lift][i] = -1;
    		}
    		else {
    			isUpdate_Intreq.push_back(i);
    		}
    	}
    }
    update_intreqs.unlock(); // unlock mutex
	
    // update moving based on requests
    if (isUpdate_Intreq.size() > 0) {
    	
    	chosenfloor = GetFloortoMove_Int(l.floor, isUpdate_Intreq);
    	if (chosenfloor != -1) {
    		if (l.floor == NumberofFloors - 1) {
				// go down
				LiftStatus[lift].direction = -1;
				LiftStatus[lift].floor = LiftStatus[lift].floor - 1;
			}

			else if (l.floor == 0) {
				// go up
				LiftStatus[lift].direction = 1;
				LiftStatus[lift].floor = LiftStatus[lift].floor + 1;
			}

			else if (l.floor > chosenfloor && l.floor > 0) {
				// go down
				LiftStatus[lift].direction = -1;
				LiftStatus[lift].floor = LiftStatus[lift].floor - 1;
			}
		
			else if (l.floor < chosenfloor && l.floor < NumberofFloors - 1) {
				// go up
				LiftStatus[lift].direction = 1;
				LiftStatus[lift].floor = LiftStatus[lift].floor + 1;
			}
		}
    }
    // there is no internal requests
    else {
    	// set the lift to be idle
    	LiftStatus[lift].direction = 0;

    	int chosenfloor_up = -1;
    	int chosenfloor_down = -1;
    	chosenfloor = -1;

    	if (isUpdate_ExreqUp.size() > 0) 
    		chosenfloor_up = GetFloortoMove_Ext(l.floor, isUpdate_ExreqUp, 0);

    	if (isUpdate_ExreqDown.size() > 0)
    		chosenfloor_down = GetFloortoMove_Ext(l.floor, isUpdate_ExreqDown, 0);

    	if ((chosenfloor_up != -1) && (chosenfloor_down != -1)) {
    		if (chosenfloor_up > chosenfloor_down) 
    			chosenfloor = chosenfloor_down;
    		else 
    			chosenfloor = chosenfloor_up;
    	}

    	else if (chosenfloor_up != -1) {
    		chosenfloor = chosenfloor_up;
    	}

    	else if (chosenfloor_down != -1) {
    		chosenfloor = chosenfloor_down;
    	}

    	else {
    		chosenfloor = -1;
    	}

    	if (chosenfloor != -1) {
    		if (l.floor > chosenfloor && l.floor > 0) {
				// go down
				LiftStatus[lift].direction = -1;
				LiftStatus[lift].floor = LiftStatus[lift].floor - 1;
			}
		
			if (l.floor < chosenfloor && l.floor < NumberofFloors - 1) {
				// go up
				LiftStatus[lift].direction = 1;
				LiftStatus[lift].floor = LiftStatus[lift].floor + 1;
			}
    	}
    }

    update_liftstatus.unlock();
}
#line 1155 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.cc"

#ifdef __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_liftsystem_cc__
#ifdef __ac_need__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#ifndef __ac_have__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#define __ac_have__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__

#line 7 "liftsystem.cc"
#endif
#endif
#undef __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#undef __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_liftsystem_cc__
#endif // __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_liftsystem_cc__
