
#line 1 "liftsystem.h"
#ifndef __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#define __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#define __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_liftsystem_h__
#endif // __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__

#line 1 "liftsystem.h"

#line 11 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"
class Automatic;

#line 1 "liftsystem.h"

#line 16 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

#ifndef __ac_h_
#define __ac_h_
#ifdef __cplusplus
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 32768, EXECUTION = 65536, CONSTRUCTION = 131072, DESTRUCTION = 262144 };
  enum Protection { PROT_NONE, PROT_PRIVATE, PROT_PROTECTED, PROT_PUBLIC };
  enum Specifiers { SPEC_NONE = 0x0 , SPEC_STATIC = 0x1, SPEC_MUTABLE = 0x2, SPEC_VIRTUAL = 0x4 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    struct { char _array[sizeof (T)]; } _data;
    ~ResultBuffer () { ((T&)_data).T::~T(); }
    operator T& () const { return (T&)_data; }
  };
  template <typename T, typename N> struct TL {
    typedef T type; typedef N next; enum { ARGS = next::ARGS + 1 };
  };
  struct TLE { enum { ARGS = 0 }; };
  template <typename T> struct Referred { typedef T type; };
  template <typename T> struct Referred<T &> { typedef T type; };
  template <typename TL, int I> struct Arg {
    typedef typename Arg<typename TL::next, I - 1>::Type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename TL> struct Arg<TL, 0> {
    typedef typename TL::type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename T> int ttest(...);
  template <typename T> char ttest(typename T::__TI const volatile *);
  template<typename T> struct HasTypeInfo {
    enum { RET=((sizeof(ttest<T>(0))==1)?1:0) };
  };
  template<typename T, int HAVE = HasTypeInfo<T>::RET> struct TypeInfo {
    enum { AVAILABLE = 0 };
  };
  template<typename T> struct TypeInfo<T, 1> : T::__TI {
    enum { AVAILABLE = 1 };
	 };
  template<typename T> struct RT {};
  template<typename T> RT<T> rt_deduce (const T&) { return RT<T>(); }
  struct Cnv { template<typename T> operator RT<T>() const { return RT<T>(); }};
  #define __AC_TYPEOF(expr) (1?AC::Cnv():AC::rt_deduce(expr))
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (unsigned long int, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __cplusplus
#endif // __ac_h_

#line 1 "liftsystem.h"

#line 84 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

#ifndef __ac_fwd_Automatic__
#define __ac_fwd_Automatic__
class Automatic;
namespace AC {
  __attribute((always_inline)) inline void invoke_Automatic_Automatic__a0_after ();
  __attribute((always_inline)) inline void invoke_Automatic_Automatic__a1_after ();
}
#endif

#ifndef __ac_need__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#define __ac_need__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#endif

#line 1 "liftsystem.h"
/*
 * This module models the behavior of a multi-lift systems.
 * The system consists of NumberofLifts lifts and NumberofFloors floors.
 * Each lift can move a distance of one floor in 0.5s
 */


#ifndef LIFTSYSTEM_H
#define LIFTSYSTEM_H

#include "systemc.h"
#include <tlm.h>
#include <limits.h>

#line 1 "global.h"
/**
 * Defines the parameters of the system
 **/

#ifndef GLOBAL_H
#define GLOBAL_H

#define NUMBEROFUSERS	5
//#define DEBUG_MODEL 	1

#include <string>
#include <iomanip>	
#include "systemc.h"


/*
 * direction: 1: up, 0: idle, -1: down
 * floor: the current position
 */
typedef struct LiftStatus {
#line 135 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

  template <typename, int = 0> struct __BYPASSLiftStatus {};
  template <typename, int> friend struct __BYPASSLiftStatus;
#line 20 "global.h"

	int direction;
	int floor;

  friend class ::Automatic;

#line 23 "global.h"
} lift_status_t;


/*
 * type, 0 : internal, 1 : external
 * targetfloor: desired floor, -1 if external
 * fromfloor: external request from, -1 if internal
 * direction: external request direction, 1: up, -1: down, 0 if internal
 * inlift: internal request in the lift inlift, -1 if external
 */

class Request {
#line 159 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"
public:
  template <typename, int = 0> struct __BYPASSRequest {};
  template <typename, int> friend struct __BYPASSRequest;
private:
#line 34 "global.h"


public:

	// constructor
	Request (int _type = -1, int _fromfloor = -1, int _targetfloor = -1, int _inlift = -1, int _direction = -1) {
		
		type = _type;
		fromfloor = _fromfloor;
		targetfloor = _targetfloor;
		inlift = _inlift;
		direction = _direction;
	}

	inline bool operator == (const Request& rhs) const {
		return (rhs.type == type && 
			    rhs.fromfloor == fromfloor &&
			    rhs.targetfloor == targetfloor &&
			    rhs.inlift == inlift &&
			    rhs.direction == direction);
	}

	inline Request& operator = (const Request& rhs) {
		type = rhs.type;
		fromfloor = rhs.fromfloor;
		targetfloor = rhs.targetfloor;
		inlift = rhs.inlift;
		direction = rhs.direction;

		return *this;
	}

	inline friend void sc_trace(sc_trace_file *tf, const Request& v, 
		const std::string& NAME) {
		sc_trace(tf, v.type, NAME + ".type");
		sc_trace(tf, v.fromfloor, NAME + ".fromfloor");
		sc_trace(tf, v.targetfloor, NAME + ".targetfloor");
		sc_trace(tf, v.inlift, NAME + ".inlift");
		sc_trace(tf, v.direction, NAME + ".direction");
	}

	inline friend ostream& operator << (ostream& os, Request const & v) {
		os << v.type << " "  << v.fromfloor << " " 
		   << v.targetfloor << " " << v.inlift << " "  
		   << v.direction;
	
		return os;
	}


private:
	int type;
	int fromfloor;
	int targetfloor;
	int inlift;
	int direction;


  friend class ::Automatic;

#line 91 "global.h"
};

#endif


#line 1 "liftsystem.h"

#line 233 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

#ifndef __ac_guard__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#define __ac_guard__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__

#line 1 "aspect_definitions.ah"
#ifndef ASPECT_DEFINITIONS_AH
#define ASPECT_DEFINITIONS_AH

#include <systemc>

#line 1 "monitor_multilift.h"
/*
 * This code is automatically generated by MAG
 * Copyright (C) 2014 Chan Ngo, INRIA
 * chan.ngo@inria.fr
 */


#ifndef MONITOR_MULTILIFT_H
#define MONITOR_MULTILIFT_H

#include <systemc.h>
#include <iostream>
#include <fstream>
#include <cassert>
#include <cstdlib>
#include <sstream>
#include <string.h>

/*
 * User objects, forward declaration
 */

class LiftSystem;

/*
 * Monitor class declaration
 */

class monitor_multilift0 : public sc_core::mon_prototype {
#line 274 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"
public:
  template <typename, int = 0> struct __BYPASSmonitor_multilift0 {};
  template <typename, int> friend struct __BYPASSmonitor_multilift0;
private:
#line 29 "monitor_multilift.h"


public:

  /*
   * Constructor
   */

  monitor_multilift0(sc_core::mon_observer* obs, LiftSystem* obj0);

  /*
   * Destructor
   */

  ~monitor_multilift0();

  /*
   * Simulate a step of the monitor.
   */

  void step();

  /*
   * Kernel-level callbacks and user-code callbacks
   */

  void callback_userloc_MovingLift();


  // Value callbacks (if any)


  /*
   * Attributes
   */

private: 

  sc_core::mon_observer* observer;
  mon_status_t status;
  LiftSystem* pnt_liftsystem;
  bool UpdateLiftStatus;
  bool MovingLift;

  friend class ::Automatic;

#line 72 "monitor_multilift.h"
};



/*
 * This object is derived from mon_observer defined in the SystemC
 * modified kernel. Thus, we can pass it as an argument to the classes
 * implementing the monitors.
 */
class local_observer : public sc_core::mon_observer {
#line 337 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"
public:
  template <typename, int = 0> struct __BYPASSlocal_observer {};
  template <typename, int> friend struct __BYPASSlocal_observer;
private:
#line 81 "monitor_multilift.h"


 public:

  // Constructor
  local_observer(unsigned int verbosity, LiftSystem* pnt_liftsystem);

  ~local_observer();

  static local_observer* getInstance();

  static local_observer* createInstance(unsigned int verbosity, LiftSystem* pnt_liftsystem);

 private:

  static local_observer* m_instance;


  friend class ::Automatic;

#line 98 "monitor_multilift.h"
};

#endif

#line 7 "aspect_definitions.ah"
#include <iostream>

class Automatic {
#line 372 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"
public:
  template <typename, int = 0> struct __BYPASSAutomatic {};
  template <typename, int> friend struct __BYPASSAutomatic;
private:
#line 9 "aspect_definitions.ah"



  // Declare the monitor objects friends, for access to private data
  
#line 13 "aspect_definitions.ah"


  
#line 17 "aspect_definitions.ah"
; // class


  // Instrumentation code for '		UpdateLiftStatus="% LiftSystem::UpdateLiftStatus(...)":exit'
  
#line 21 "aspect_definitions.ah"

#line 395 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

public: void __a0_after 
#line 21 "aspect_definitions.ah"
() {

#ifdef DEBUG_INSTRUMENTATION
      std::cout << "Join Point signature: " << JoinPoint::signature() << std::endl;
      std::cout << "Using advice: execution(\"% LiftSystem::UpdateLiftStatus(...)\"): after()" << std::endl;
      std::cout << "For user location 		UpdateLiftStatus=\"% LiftSystem::UpdateLiftStatus(...)\":exit" << std::endl;
#endif

  }
#line 408 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

private:

#line 29 "aspect_definitions.ah"
 // advice


  // Instrumentation code for '		MovingLift="% LiftSystem::MovingLift(...)":exit'
  
#line 33 "aspect_definitions.ah"

#line 420 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

public: void __a1_after 
#line 33 "aspect_definitions.ah"
() {

#ifdef DEBUG_INSTRUMENTATION
      std::cout << "Join Point signature: " << JoinPoint::signature() << std::endl;
      std::cout << "Using advice: execution(\"% LiftSystem::MovingLift(...)\"): after()" << std::endl;
      std::cout << "For user location 		MovingLift=\"% LiftSystem::MovingLift(...)\":exit" << std::endl;
#endif

    {
      mon_observer* observer = local_observer::getInstance();
      monitor_multilift0* mon = (monitor_multilift0*) observer->get_monitor_by_index(0);
      mon->callback_userloc_MovingLift();
    }
  }
#line 438 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

private:

#line 46 "aspect_definitions.ah"
 // advice




public:
  static Automatic *aspectof () {
    static Automatic __instance;
    return &__instance;
  }
  static Automatic *aspectOf () {
    return aspectof ();
  }
private:

#line 49 "aspect_definitions.ah"
};
#line 460 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

namespace AC {
  __attribute((always_inline)) inline void invoke_Automatic_Automatic__a0_after () {
    ::Automatic::aspectof()->__a0_after ();
  }
  __attribute((always_inline)) inline void invoke_Automatic_Automatic__a1_after () {
    ::Automatic::aspectof()->__a1_after ();
  }
} 

#line 49 "aspect_definitions.ah"
 // Automatic



#endif

#line 7 "liftsystem.h"
#endif

#line 17 "liftsystem.h"
struct LiftSystem : ::sc_core::sc_module {
#line 483 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

  template <typename, int = 0> struct __BYPASSLiftSystem {};
  template <typename, int> friend struct __BYPASSLiftSystem;
#line 17 "liftsystem.h"


	SC_HAS_PROCESS(LiftSystem);
	
public:

	// ports to connect to users
	sc_in < Request > reqs_p[NUMBEROFUSERS];
	sc_event receive_req_e;

	// Contructor
	LiftSystem(sc_module_name name, unsigned int lifts, unsigned int floors);


	void GetRequests();

	void UpdateLifts();

	void ReceiveRequests();

	void AssignExternalRequest(int level, int up);

	void AssignInternalRequest(int lift, int level);

	// a lift's behavior
	
#line 514 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"
public: __attribute__((always_inline)) inline void __exec_old_UpdateLiftStatus(int lift);

#line 42 "liftsystem.h"
void UpdateLiftStatus(int lift);

	
#line 521 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"
public: __attribute__((always_inline)) inline void __exec_old_MovingLift(int lift);

#line 44 "liftsystem.h"
void MovingLift(int lift);

	// get target floor to move for a lift
	int GetFloortoMove_Ext(int fromfloor, std::vector < int > targets, int direction);

	int GetFloortoMove_Int(int fromfloor, std::vector < int > targets);

	int ComputeMinimumDistance(int level, int up);

	// passby check
	void PassbyCheck();

private:
	// mutex for access shared data
	sc_mutex update_exreqs_up;
	sc_mutex update_exreqs_down;
	sc_mutex update_intreqs;
	sc_mutex update_liftstatus;

	// number of lifts
	unsigned int NumberofLifts;

	// number of floors
	unsigned int NumberofFloors;

	std::vector< int > ExternalRequestsUp;

	std::vector< int > ExternalRequestsDown;
	
	std::vector< std::vector< int > > InternalRequests;

	// model the lifts
	std::vector< lift_status_t > LiftStatus;

	// passby
	int passby;

   private:

#line 16 ""
 friend class monitor_multilift0 ;
  friend class ::Automatic;

#line 81 "liftsystem.h"
};

#endif
#line 572 "/home/channgo/Working/plasma_plugins/trunk/stochastic_SystemC/examples/multi-lift_v1/instrumented/liftsystem.h"

#ifdef __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_liftsystem_h__
#ifdef __ac_need__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#ifndef __ac_have__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__
#define __ac_have__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_aspect_definitions_ah__

#line 7 "liftsystem.h"
#endif
#endif
#undef __ac_FIRST__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src__
#undef __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_liftsystem_h__
#endif // __ac_FIRST_FILE__home_channgo_Working_plasma_plugins_trunk_stochastic_SystemC_examples_multiX45lift_v1_src_liftsystem_h__
