#include <time.h>
#include "user.h"
#include "liftsystem.h"
#include "global.h"

#include "monitor_multilift.h"

int sc_main(int argc, char *argv[]) {

  int numberoflifts = 10;
  int numberoffloors = 30;

  srand(time(NULL));  // set the "seed" for randomization
  
  // set simulation time unit
  sc_set_time_resolution(1, SC_SEC);

  // signals to connect users and lift controller
  sc_buffer< Request > sigs [NUMBEROFUSERS];

  // the lift system
  LiftSystem liftsystem("liftsystem", numberoflifts, numberoffloors);
  
  // users
  User user1("user1", numberoflifts, numberoffloors);
  User user2("user2", numberoflifts, numberoffloors);
  User user3("user3", numberoflifts, numberoffloors);
  User user4("user4", numberoflifts, numberoffloors);
  User user5("user5", numberoflifts, numberoffloors);

  // binding
  for (int i = 0; i < NUMBEROFUSERS; i++) {
  	liftsystem.reqs_p[i](sigs[i]);
  	//users[i].req_p(sigs[i]);
  }
  
  user1(sigs[0]);
  user2(sigs[1]);
  user3(sigs[2]);
  user4(sigs[3]);
  user5(sigs[4]);

  // Begin - instantiate obs
  mon_observer* obs = local_observer::createInstance(1, &liftsystem);
  // End - instantiate obs

  sc_start (); // The monitor will stop the simulator
  
  // End of program
  return 0;
}
