/*
 * This code is automatically generated by MAG
 * Copyright (C) 2014 Chan Ngo, INRIA
 * chan.ngo@inria.fr
 */


/*
 * User's includes to cc file
 */

#include "liftsystem.h"
#include "monitor_multilift.h"

/*
 * Monitor's formula:
 */

//	 PBLTL forumula: F <= #1000 (passby = 1) 
//	 clock(s): 
//			MovingLift
//


/*
 * Constructor
 */

monitor_multilift0::monitor_multilift0(sc_core::mon_observer* obs, LiftSystem* obj0) : sc_core::mon_prototype() {

  // Observer
  observer = obs;
  // Usertypes
  pnt_liftsystem = obj0;
  // Locations
  UpdateLiftStatus = false;
  MovingLift = false;
  // Plocations
  // Value callbacks
  // Attributes - nothing to initialization
  // Event clocks
  // Register with observer
}

/*
 * Destructor
 */

monitor_multilift0::~monitor_multilift0() {

}

/*
 * Simulate a step of the monitor.
 */

void
monitor_multilift0::step() {
  //Get command from standard input - stdin
  std::string cmd;

  while (true) {
    std::getline(std::cin, cmd);
    // Get quit command
    if (strcmp(cmd.c_str(), "#plasma-quit#") == 0) {
      sc_stop();
      std::cout << "\n# plasma-quit at " << sc_time_stamp() << " #\n" << std::endl;
      exit (0);
    }

    // Get an invalid command
    else if (strcmp(cmd.c_str(), "#plasma-newstate#") != 0) {
      // Wait for a valid command
      continue;
    }

    // Get a new state request
    else {
      // Process the command
      break;
    }
  }

  std::stringstream outputstate;
  outputstate.str ();
  outputstate << "\n# plasma-state [ (";


  // Log attributes values
  outputstate << "er0";
  outputstate << " : ";
  outputstate << pnt_liftsystem->ExternalRequestsUp[0];
  outputstate << ", ";

  outputstate << "er2";
  outputstate << " : ";
  outputstate << pnt_liftsystem->ExternalRequestsUp[2];
  outputstate << ", ";

  outputstate << "ld0";
  outputstate << " : ";
  outputstate << pnt_liftsystem->LiftStatus[0].direction;
  outputstate << ", ";

  outputstate << "lf0";
  outputstate << " : ";
  outputstate << pnt_liftsystem->LiftStatus[0].floor;
  outputstate << ", ";

  outputstate << "passby";
  outputstate << " : ";
  outputstate << pnt_liftsystem->passby;



  // Log event clocks - Boolean


  // Log locations - Boolean
  outputstate << ", ";
  if (UpdateLiftStatus) {
    outputstate << "UpdateLiftStatus";
    outputstate << " : ";
    outputstate << "true";
    outputstate << ", ";
  }
  else {
    outputstate << "UpdateLiftStatus";
    outputstate << " : ";
    outputstate << "false";
    outputstate << ", ";
  }
  if (MovingLift) {
    outputstate << "MovingLift";
    outputstate << " : ";
    outputstate << "true";
  }
  else {
    outputstate << "MovingLift";
    outputstate << " : ";
    outputstate << "false";
  }


  // Log pattern locations - plocation - Boolean


  // Log callback values

  // Send the logged state to stdout
  outputstate << ")" << " : ";
  outputstate << sc_time_stamp() ;
  outputstate << " ] #\n" << std::endl;
  std::cout << outputstate.str();
}


void
monitor_multilift0::callback_userloc_MovingLift() {

  #ifdef DEBUG_USERLOCS
    std::cout << "monitor_multilift0::MovingLift callback" << std::endl << std::endl;
  #endif

  // Set the value of the primitive
  MovingLift = true;

  step();

  // Reset the value of the primitive
  MovingLift = false;
}


// static instance variable
local_observer* local_observer::m_instance;



/*
 * Constructor
 */
local_observer::local_observer(unsigned int verbosity, LiftSystem* pnt_liftsystem) : sc_core::mon_observer(verbosity) {

  monitor_multilift0* monitor_multilift0_inst = new monitor_multilift0(this, pnt_liftsystem);
  mons.push_back(monitor_multilift0_inst);

}

/*
 * Destructor
 */
local_observer::~local_observer() {

}
/*
 * Create instance
 */
local_observer* local_observer::createInstance(unsigned int verbosity, LiftSystem* pnt_liftsystem) {

  if (m_instance == NULL) {
    m_instance = new local_observer(verbosity, pnt_liftsystem);  }

  return m_instance;

}

/*
 * Get instance
 */
local_observer* local_observer::getInstance() {

  return m_instance;

}
