#include "user.h"

User::User(sc_module_name name, unsigned int lifts, unsigned int floors) : sc_module(name) {

	// intialization
	NumberofLifts = lifts;
	NumberofFloors = floors;

	SC_THREAD(GenerateRequest);

}

void User::GenerateRequest() {

	while (true) {
		wait(1, SC_SEC);

		// generate request
		Request req1 = RandomRequest();
		req_p.write(req1);
	}
}


Request User::RandomRequest() {

	int type = -1;
	int fromfloor = -1;
	int targetfloor = -1;
	int inlift = -1;
	int direction = 0;

	// external requests
	int gettype = rand() % NumberofLifts;
	if (gettype == 0 || gettype == 1) {
		type = 1;
		// request up
      	if (rand() % 2) {
      		direction = 1;
      		fromfloor = rand() % (NumberofFloors - 1);
      	}
      	// request down
      	else {
      		direction = -1;
      		fromfloor = (rand() % (NumberofFloors-1)) + 1;
      	}
	}
	// internal requests
	else {
		type = 0;
		targetfloor = rand() % NumberofFloors;
		inlift = rand() % NumberofLifts;
	}

	// generate the request
	Request req(type, fromfloor, targetfloor, inlift, direction);
	
	return req;
}