/**
 * Defines the functionality of a user
 **/

#ifndef USER_H
#define USER_H

#include "systemc.h"
#include <tlm.h>
#include "global.h"

 SC_MODULE(User) {

 	SC_HAS_PROCESS(User);

 public:

 	sc_out < Request > req_p;

 	// Contructor
	User(sc_module_name name, unsigned int lifts, unsigned int floors);

	void GenerateRequest();

	Request RandomRequest();

 private:
 	
 	// number of lifts
	unsigned int NumberofLifts;

	// number of floors
	unsigned int NumberofFloors;	
 };


#endif

